// LibExtractorDlg.cpp : implementation file
//

#include "stdafx.h"
#include "LibExtractor.h"
#include "LibExtractorDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CLibExtractorDlg dialog


CLibExtractorDlg::CLibExtractorDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLibExtractorDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CLibExtractorDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CLibExtractorDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLibExtractorDlg)
	DDX_Control(pDX, IDC_TARGETFILE, m_TargetFile);
	DDX_Control(pDX, IDC_DEPEND, m_Depend);
	DDX_Control(pDX, IDC_SELECTEDDEVICE, m_SelectedDevice);
	DDX_Control(pDX, IDC_CURRLIBRTEXT, m_CurrLibr);
	DDX_Control(pDX, IDC_SYMLIST, m_SymList);
	DDX_Control(pDX, IDC_PACLIST, m_PacList);
	DDX_Control(pDX, IDC_DEVLIST, m_DevList);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CLibExtractorDlg, CDialog)
	//{{AFX_MSG_MAP(CLibExtractorDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_LOADBROWSE, OnLoadbrowse)
	ON_LBN_SELCHANGE(IDC_DEVLIST, OnSelchangeDevlist)
	ON_BN_CLICKED(IDC_SAVEBROWSE, OnSavebrowse)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLibExtractorDlg message handlers

BOOL CLibExtractorDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CLibExtractorDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CLibExtractorDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CLibExtractorDlg::OnLoadbrowse() 
{
	CFileDialog	cDialog(TRUE,"*.scr",NULL,NULL,"Script Files (*.scr)|*.scr|All Files (*.*)|*.*||",this);

	if ((cSourceFileName!="")&&(hSourceFile!=INVALID_HANDLE_VALUE))
		CloseHandle (hSourceFile);

	if (cDialog.DoModal() == IDOK)
	{
		// zpracovani
		cSourceFileName = cDialog.GetPathName();			// mame jmeno souboru
		// zjistime, jestli soubor existuje
		if ((hSourceFile=CreateFile(cSourceFileName,GENERIC_READ,0,0,OPEN_EXISTING,0,NULL)) == INVALID_HANDLE_VALUE)
		{
			MessageBox ("Cannot open specified script file","Error",MB_OK);
			cSourceFileName = "";
			return;
		}
		m_CurrLibr.SetWindowText (cDialog.GetFileName());
		// file Exists, load the contents
		LoadData ();
	}
}

BOOL CLibExtractorDlg::LoadData()
{
	CWaitCursor hodiny;
	CString cLine;
	CStringList *Deps;
	int LastDependency = -1;						// -1 = zadny posledni neni, v tom pripade je nekde krpa
	BOOL LastDevice = FALSE;

	m_SymList.ResetContent();
	m_PacList.ResetContent();
	m_DevList.ResetContent();
	
	// prvni vec, kterou provedeme je nacitani souboru do te doby, nez zjistime CR\LF - 0x0d, 0x0a
	while (!LoadLine(cLine))
	{
		cLine.MakeUpper();
		if (cLine.Left (4) == "EDIT")
		{
			LastDevice=FALSE;
			// mame prikaz k editaci nejakeho elementu, zjistime o co de
			CString cName = cLine.Mid (5,cLine.GetLength()-10);
			if (cLine.Right(4) == "SYM;")
			{
				// zjistime kde je mezera a udelame  si nazev symbolu
				m_SymList.AddString (cName);	
			} else
			if (cLine.Right(4) == "DEV;")
			{
				// zjistime kde je mezera a udelame  si nazev symbolu
				LastDependency = m_DevList.AddString (cName);
				Deps = new CStringList();
				m_DevList.SetItemData (LastDependency,(unsigned long)Deps);
				LastDevice=TRUE;
			} else
			if (cLine.Right(4) == "PAC;")
			{
				// zjistime kde je mezera a udelame  si nazev symbolu
				m_PacList.AddString (cName);	
			} else
			{
				MessageBox ("Unknown EDIT structure in specified script! Cannot continue","Error",MB_OK);
				return 1;
			}

		} else
		if ((cLine.Left (3) == "ADD")&&(LastDevice==TRUE))
		{
			// zpracovavame DEV, jehoz dependency je ulozena v LastDependency
			CString cName = cLine.Right (cLine.GetLength()-cLine.Find (' ')-1);
			CString cName1 = CString ("SYM - ")+cName.Left(cName.Find(' '));
			Deps = (CStringList*)m_DevList.GetItemData (LastDependency);
			if (Deps != NULL)
			{
				Deps->AddTail (cName1);
			}

		} else
		if ((cLine.Left (7) == "PACKAGE")&&(LastDevice==TRUE))
		{
			// zpracovavame DEV, jehoz dependency je ulozena v LastDependency
			CString cName = cLine.Right (cLine.GetLength()-cLine.Find (' ')-2);
			CString cName1 = CString ("PAC - ")+cName.Left(cName.GetLength()-2);
			Deps = (CStringList*)m_DevList.GetItemData (LastDependency);
			if (Deps != NULL)
			{
				Deps->AddTail (cName1);
			}

		}
	}
	return 0;
}


BOOL CLibExtractorDlg::LoadLine(CString & cLine)
{
	DWORD dRead;
	char c;

	cLine = "";
	// nactejeden radek ze souboru
	while (1)
	{
		ReadFile (hSourceFile,&c,1,&dRead,NULL);
		if (dRead==0) return TRUE;			// konec, 
		if (c == 0x0d)
		{
			ReadFile (hSourceFile,&c,1,&dRead,NULL);
			if (dRead==0) return TRUE;
			return FALSE;													// OK, mame retezec
		}
		cLine = cLine + c;
	}
}

void CLibExtractorDlg::OnSelchangeDevlist() 
{
	char DevName[20];
	CStringList *data;
	int nCurrentIndex;
	POSITION pos;
	// tedy musime zajistit 1) nastaveni spravneho jmena v 	Selected Device, druha vec je vyplnit list
	// dependencies
	m_DevList.GetText((nCurrentIndex=m_DevList.GetCaretIndex()),DevName);
	m_SelectedDevice.SetWindowText (CString(DevName)+CString(".DEV"));
	// tedkajc vymazeme polozky z listu depend
	m_Depend.ResetContent();		// nejdriv oznacit vsechny
	// nasleduje prochazeni listem z current
	data = (CStringList*)m_DevList.GetItemData (nCurrentIndex);
	pos = data->GetHeadPosition();
	if (pos == NULL)
		m_Depend.AddString ("No dependencies");
	else
	{
		CString shit = data->GetHead();
		int wheel = data->GetCount();
		int wrack;
		for (wrack = 0; wrack < wheel;wrack++)
		{
			shit = data->GetNext(pos);
			m_Depend.AddString(shit);
		}
	}
}

void CLibExtractorDlg::OnSavebrowse() 
{
	CFileDialog	cDialog(FALSE,"*.scr",NULL,NULL,"Script Files (*.scr)|*.scr|All Files (*.*)|*.*||",this);

	do{
		if (cDialog.DoModal() == IDOK)
		{
			// zpracovani
			cTargetFileName = cDialog.GetPathName();			// mame jmeno souboru
			// zjistime, jestli soubor existuje
			if ((hTargetFile=CreateFile(cTargetFileName,GENERIC_READ,0,0,OPEN_EXISTING,0,NULL)) != INVALID_HANDLE_VALUE)
			{
				CloseHandle (hTargetFile);
				int Result = MessageBox ("File exists. Overwrite?","Exclamation",MB_YESNOCANCEL|MB_ICONEXCLAMATION);
				if (Result == IDCANCEL) return;
				if (Result == IDNO)
				{
					// deleting the file to recreate new one - simply runs out the 
					cTargetFileName = "";
				}
			}
		}
	} while (cTargetFileName == "");
	// tady mame jmeno souboru, dame jej do editacniho boxu
	m_TargetFile.SetSel (0,-1);			// vyber vsechno
	m_TargetFile.ReplaceSel (cTargetFileName);
}

void CLibExtractorDlg::OnOK() 
{
	DWORD buff;
	CWaitCursor hodiny;
	BOOL Allow = TRUE;
	CString cLine;

	// tady se to vsecko sere. nejdriv otestujeme, zda existuje vstupni soubor a je otevreny
	CloseHandle(hSourceFile);
	hSourceFile=CreateFile(cSourceFileName,GENERIC_READ,0,0,OPEN_EXISTING,0,NULL);
	if (hSourceFile == INVALID_HANDLE_VALUE)
	{
		MessageBox ("Invalid input script file or no file opened!","Error",MB_ICONSTOP|MB_OK);
		return;
	}

	if ((hTargetFile=CreateFile(cTargetFileName,GENERIC_WRITE,0,0,CREATE_ALWAYS,0,NULL)) == INVALID_HANDLE_VALUE)
	{
		MessageBox ("Cannot create output file! Disk probably full.","Error",MB_ICONSTOP|MB_OK);
		return;
	}

	
	
	// mame otevreny vstupni a vystupni soubor. ted seekneme na zacatek a pojedeme linku po lince
	while (!LoadLine(cLine))
	{
		// protoze jsme na zacatku, zapiseme radek do vystupniho souboru
		CString cLineOut = cLine+CString("\r\n");
		cLine.MakeUpper();
		if (cLine.Left (4) == "EDIT")
		{
			// mame prikaz k editaci nejakeho elementu, zjistime o co de
			CString cName = cLine.Mid (5,cLine.GetLength()-10);
			if (cLine.Right(4) == "SYM;")
			{
				// zjistime kde je mezera a udelame  si nazev symbolu
				Allow = CheckInclusion(cName,1);
			} else
			if (cLine.Right(4) == "DEV;")
			{
				Allow = CheckInclusion(cName,2);
			} else
			if (cLine.Right(4) == "PAC;")
			{
				// zjistime kde je mezera a udelame  si nazev symbolu
				Allow = CheckInclusion(cName,3);
			} 
		}
		if (Allow==TRUE)				// pokud je povoleny zapis, je to ok
			WriteFile (hTargetFile,cLineOut,cLineOut.GetLength(),&buff,NULL);
	}


	CloseHandle (hSourceFile);
	CloseHandle (hTargetFile);
	CDialog::OnOK();
}

BOOL CLibExtractorDlg::CheckInclusion(CString & cName, int Type)
{
	// type = 1SYM, 2DEV, 3PAC
	if (Type==1)
	{
		return m_SymList.GetSel(m_SymList.FindStringExact(-1,cName));
	} else
	if (Type==2)
	{
		return m_DevList.GetSel(m_DevList.FindStringExact(-1,cName));
	} else
	if (Type==3)
	{
		return m_PacList.GetSel(m_PacList.FindStringExact(-1,cName));
	} 
	return FALSE;
}
